SystemOrganization addCategory: #'Glamour-Reporter'!
SystemOrganization addCategory: #'Glamour-Reporter-Tests'!

TestCase subclass: #REPConcernBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Reporter-Tests'!

!REPConcernBuilderTest methodsFor: 'as yet unclassified' stamp: 'tg 5/12/2010 11:14'!
testBasicQueryCreation
	| spec |
	spec := REPConcernSpecification on: 42.
	spec query: 'Label' meaning: 'Explanation' as: [:x | x + 1].
	self assert: spec root children size = 1.
	self assert: spec root children first label = 'Label'.
	self assert: spec root children first explanation = 'Explanation'.
	self assert: spec root children first model = 42.
	self assert: spec root children first result = 43! !

!REPConcernBuilderTest methodsFor: 'as yet unclassified' stamp: 'tg 5/11/2010 00:42'!
testComposition
	| spec |

	spec := REPConcernSpecification on: 42.

	spec composite: 'One' with: [
		spec concern: (REPConcern new)].
	spec composite: 'Two' with: [
		spec concern: (REPConcern new).
		spec concern: (REPConcern new)].

	self assert: spec root children size = 2.
	self assert: spec root children first children size = 1.
	self assert: spec root children last children size = 2.
	self assert: spec root children first label = 'One'
! !

!REPConcernBuilderTest methodsFor: 'as yet unclassified' stamp: 'tg 5/11/2010 00:12'!
testCustomConcern
	| spec |
	spec := REPConcernSpecification on: 42.
	spec concern: REPConcern new.
	self assert: spec root children first model = 42! !

!REPConcernBuilderTest methodsFor: 'as yet unclassified' stamp: 'tg 5/10/2010 23:41'!
testRoot
	self assert: (REPConcernSpecification on: 42) root model = 42! !

TestCase subclass: #REPConcernTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Reporter-Tests'!

!REPConcernTest methodsFor: 'as yet unclassified' stamp: 'tg 5/12/2010 11:13'!
testDefaultStatus
	self assert: REPComputedConcern new status notNil.
	self assert: REPComputedConcern new status color = TextColor black.
	self assert: REPComputedConcern new status label notNil! !

!REPConcernTest methodsFor: 'as yet unclassified' stamp: 'tg 5/10/2010 23:17'!
testDefaults
	self assert: REPConcern new label = #REPConcern.
	self assert: REPConcern new explanation = #REPConcern.! !

!REPConcernTest methodsFor: 'as yet unclassified' stamp: 'tg 5/12/2010 11:17'!
testInfoConcernStatus
	self assert: REPInfoConcern new statusValue isNil! !

GLMBrowserTemplate subclass: #REPConcernBrowser
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Reporter'!

!REPConcernBrowser classSide methodsFor: 'as yet unclassified' stamp: 'tg 5/10/2010 23:10'!
openOn: aConcern
	^ self new openOn: aConcern! !

!REPConcernBrowser methodsFor: 'as yet unclassified' stamp: 'tg 5/12/2010 15:43'!
buildBrowser
	browser := GLMTabulator withStatusbar.
	browser title: [ :concern | concern label ].
	browser column: [: c | 
		c row: #list span: 4; row: #explanation ]; column: #results span: 4.
	browser transmit to: #list; andShow: [:a |
		a tree 
			title: 'Index';
			display: [ :concern | concern children ];
			children: #children;
			format: [ :concern | concern status label ]].
	browser transmit to: #results; from: #list; andShow: [:a |
		a dynamic
			title: #label;
			display: [:each | each browser noTitle ] ].
	browser transmit to: #explanation; from: #list; andShow: [:a |
		a text 
			display: #explanation ].
	^ browser ! !

GLMBrowserTemplate subclass: #REPReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Reporter'!

!REPReport classSide methodsFor: 'as yet unclassified' stamp: 'tg 5/18/2010 07:03'!
open 
	^ self new open! !

!REPReport methodsFor: 'private' stamp: 'tg 5/18/2010 07:13'!
build: spec 
	"override this method to build your spec"
	^ self subclassResponsibility! !

!REPReport methodsFor: 'private' stamp: 'tg 5/18/2010 07:13'!
model 
	"override this method to point to the model of the specification"
	^ self subclassResponsibility! !

!REPReport methodsFor: 'public' stamp: 'tg 5/18/2010 07:03'!
open 
	^ self spec open! !

!REPReport methodsFor: 'accessing' stamp: 'tg 5/18/2010 07:13'!
spec 
	| spec |
	spec := REPConcernSpecification on: self model.
	self build: spec.
	^ spec! !

Object subclass: #REPConcern
	instanceVariableNames: 'model label explanation condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Reporter'!

REPConcern subclass: #REPCompositeConcern
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Reporter'!

!REPCompositeConcern methodsFor: 'accessing' stamp: 'tg 5/10/2010 22:57'!
addChild: aConcern
	^ self children add: aConcern! !

!REPCompositeConcern methodsFor: 'accessing' stamp: 'tg 5/10/2010 22:40'!
children
	^ children! !

!REPCompositeConcern methodsFor: 'accessing' stamp: 'tg 5/10/2010 22:40'!
children: anObject
	children := anObject! !

!REPCompositeConcern methodsFor: 'initialize-release' stamp: 'tg 5/10/2010 23:17'!
initialize
	super initialize.
	children := OrderedCollection new! !

!REPCompositeConcern methodsFor: 'testing' stamp: 'tg 5/11/2010 00:40'!
isComposite
	^ true! !

!REPCompositeConcern methodsFor: 'accessing' stamp: 'tg 5/11/2010 00:40'!
leafChildrenDo: aBlock
	self children do: [:each |
		each isComposite 
			ifFalse: [aBlock value: each ]
			ifTrue: [each leafChildrenDo: aBlock ]]! !

!REPCompositeConcern methodsFor: 'accessing' stamp: 'tg 5/11/2010 00:39'!
statusValue
	| hasTrue hasFalse |
	hasTrue := false.
	hasFalse := false.
	self leafChildrenDo: [ :each | 
		each statusValue = false ifTrue: [ hasFalse := true ].
		each statusValue = true ifTrue: [ hasTrue := true ] ].
	hasFalse ifTrue: [ ^ false ].
	hasTrue ifTrue: [ ^ true ].
	^ nil ! !

REPConcern subclass: #REPComputedConcern
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Reporter'!

!REPComputedConcern methodsFor: 'accessing' stamp: 'tg 5/12/2010 11:13'!
computeResult 
	^ nil! !

!REPComputedConcern methodsFor: 'accessing' stamp: 'tg 5/12/2010 11:09'!
result 
	^ result ifNil: [ result := self computeResult ]! !

REPComputedConcern subclass: #REPQueryConcern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Reporter'!

REPQueryConcern subclass: #REPCustomQueryConcern
	instanceVariableNames: 'computation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Reporter'!

!REPCustomQueryConcern methodsFor: 'accessing' stamp: 'tg 5/12/2010 11:10'!
computation
	^ computation! !

!REPCustomQueryConcern methodsFor: 'accessing' stamp: 'tg 5/12/2010 11:10'!
computation: anObject
	computation := anObject! !

!REPCustomQueryConcern methodsFor: 'as yet unclassified' stamp: 'tg 5/12/2010 10:35'!
computeResult 
	^ self computation glamourValue: self model asGlamorousMultiValue ! !

!REPQueryConcern methodsFor: 'accessing' stamp: 'tg 5/8/2010 15:38'!
browser
	^ (MooseFinder startOn: self result) noTitle! !

!REPQueryConcern methodsFor: 'accessing' stamp: 'tg 5/11/2010 07:58'!
statusValue 
	^ self result notNil and: [ self result isEmpty ]! !

!REPConcern classSide methodsFor: 'as yet unclassified' stamp: 'tg 5/10/2010 21:39'!
on: aModel
	^ self new 
		model: aModel;
		yourself! !

!REPConcern methodsFor: 'accessing' stamp: 'tg 5/10/2010 23:34'!
browser
	| browser |
	browser := GLMTabulator new.
	browser title: #label.
	browser column: #explanation.
	browser transmit to: #explanation; andShow: [:a | 
		a text 
			display: #explanation ].
	^ browser ! !

!REPConcern methodsFor: 'accessing' stamp: 'tg 5/10/2010 22:40'!
children 
	^ OrderedCollection new! !

!REPConcern methodsFor: 'accessing' stamp: 'tg 5/10/2010 23:43'!
condition
	^ condition! !

!REPConcern methodsFor: 'accessing' stamp: 'tg 5/10/2010 23:43'!
condition: anObject
	condition := anObject! !

!REPConcern methodsFor: 'accessing' stamp: 'tg 5/12/2010 15:38'!
explanation
	^ explanation! !

!REPConcern methodsFor: 'accessing' stamp: 'tg 5/10/2010 22:59'!
explanation: anObject
	^ explanation := anObject! !

!REPConcern methodsFor: 'initialize-release' stamp: 'tg 5/12/2010 11:12'!
initialize 
	label := explanation := self class name.
	condition := [nil] "the status is undefined by default".! !

!REPConcern methodsFor: 'testing' stamp: 'tg 5/11/2010 00:40'!
isComposite
	^ false! !

!REPConcern methodsFor: 'accessing' stamp: 'tg 5/10/2010 22:58'!
label 
	^ label! !

!REPConcern methodsFor: 'accessing' stamp: 'tg 5/10/2010 22:58'!
label: anObject
	label := anObject! !

!REPConcern methodsFor: 'accessing' stamp: 'tg 5/10/2010 21:38'!
model
	^ model! !

!REPConcern methodsFor: 'accessing' stamp: 'tg 5/10/2010 21:38'!
model: anObject
	model := anObject! !

!REPConcern methodsFor: 'accessing' stamp: 'tg 5/12/2010 11:11'!
result 
	^ self subclassResponsibility! !

!REPConcern methodsFor: 'accessing' stamp: 'tg 5/11/2010 00:23'!
status
	^ (REPConcernStatus new)
		concern: self;
		value: self statusValue;
		yourself! !

!REPConcern methodsFor: 'accessing' stamp: 'tg 5/11/2010 00:31'!
statusValue
	^ self condition 
		glamourValue: self result asGlamorousMultiValue , 
		self model asGlamorousMultiValue! !

!REPConcern methodsFor: 'accessing' stamp: 'tg 5/10/2010 23:01'!
withAllChildrenDo: aBlock
	aBlock value: self.
	self children do: [:each |
		each withAllChildrenDo: aBlock ]! !

Object subclass: #REPConcernSpecification
	instanceVariableNames: 'root model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Reporter'!

!REPConcernSpecification classSide methodsFor: 'instance creation' stamp: 'tg 5/10/2010 22:51'!
on: aModel
	^ self new 
			model: aModel;
			yourself! !

!REPConcernSpecification methodsFor: 'concern building' stamp: 'tg 5/11/2010 08:39'!
composite: aString meaning: anExplanationString with: aBlock 
	| state |
	state := self shallowCopy.
	self root: (self concern: ((
		REPCompositeConcern on: self model) 
			label: aString; 
			explanation: anExplanationString;
			yourself)).
	aBlock ensure: [ self copyFrom: state ]! !

!REPConcernSpecification methodsFor: 'concern building' stamp: 'tg 5/11/2010 08:40'!
composite: aString with: aBlock 
	^ self composite: aString meaning: aString with: aBlock! !

!REPConcernSpecification methodsFor: 'concern building' stamp: 'tg 5/11/2010 00:13'!
concern: aConcern
	^ self root addChild: (aConcern model: self model; yourself)! !

!REPConcernSpecification methodsFor: 'initialize-release' stamp: 'tg 5/10/2010 23:00'!
initialize
	root := REPCompositeConcern new! !

!REPConcernSpecification methodsFor: 'accessing' stamp: 'tg 5/10/2010 23:18'!
label: aString 
	self root label: aString! !

!REPConcernSpecification methodsFor: 'accessing' stamp: 'tg 5/10/2010 22:52'!
model
	^ model! !

!REPConcernSpecification methodsFor: 'accessing' stamp: 'tg 5/10/2010 23:01'!
model: anObject
	model := anObject.
	self root withAllChildrenDo: [:each | each model: anObject ]! !

!REPConcernSpecification methodsFor: 'opening' stamp: 'tg 5/10/2010 23:11'!
open 
	^ REPConcernBrowser openOn: self root ! !

!REPConcernSpecification methodsFor: 'concern building' stamp: 'tg 5/12/2010 10:36'!
query: aLabelString meaning: aMeaningString as: aBlock
	^ self root addChild: 
		((REPCustomQueryConcern on: self model)
			computation: aBlock;
			label: aLabelString;
			explanation: aMeaningString;
			yourself )! !

!REPConcernSpecification methodsFor: 'accessing' stamp: 'tg 5/10/2010 22:51'!
root
	^ root! !

!REPConcernSpecification methodsFor: 'accessing' stamp: 'tg 5/10/2010 22:51'!
root: anObject
	root := anObject! !

Object subclass: #REPConcernStatus
	instanceVariableNames: 'value concern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Reporter'!

!REPConcernStatus methodsFor: 'accessing' stamp: 'tg 5/12/2010 15:42'!
color 
	self value = true ifTrue: [ ^ TextColor  new color: Color green muchDarker ].
	self value = false ifTrue: [ ^ TextColor  new color: Color red darker ].
	^ TextColor black! !

!REPConcernStatus methodsFor: 'accessing' stamp: 'tg 5/10/2010 23:52'!
concern
	^ concern! !

!REPConcernStatus methodsFor: 'accessing' stamp: 'tg 5/10/2010 23:52'!
concern: anObject
	concern := anObject! !

!REPConcernStatus methodsFor: 'accessing' stamp: 'tg 5/11/2010 00:21'!
label 
	^ Text string: self concern label attribute: self color! !

!REPConcernStatus methodsFor: 'accessing' stamp: 'tg 5/10/2010 23:49'!
value
	^ value! !

!REPConcernStatus methodsFor: 'accessing' stamp: 'tg 5/10/2010 23:49'!
value: anObject
	value := anObject! !
